<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\master_worker;


use app\common\model\master_worker\BankAccount;
use app\common\model\master_worker\MasterWorker;
use app\common\model\master_worker\MasterWorkerAgree;
use app\common\logic\BaseLogic;
use app\common\model\master_worker\MasterWorkerInfo;
use think\facade\Db;


/**
 * MasterWorkerExamineLogic逻辑
 * Class MasterWorkerExamineLogic
 * @package app\adminapi\logic\master_worker
 */
class MasterWorkerExamineLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            MasterWorkerAgree::create([
                'agree_type' => $params['agree_type'],
                'worker_id' => $params['worker_id'],
                'sign' => $params['sign'],
                'pdf_url' => $params['pdf_url'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            !empty($params['workerInfo']['id']) && MasterWorkerInfo::where('id', $params['workerInfo']['id'])->update([
                'audit_state' => $params['workerInfo']['audit_state'],
            ]);
            !empty($params['workerAgree']['id']) && MasterWorkerAgree::where('id', $params['workerAgree']['id'])->update([
                'audit_state' => $params['workerAgree']['audit_state'],
            ]);
            !empty($params['bankAccount']['id']) && BankAccount::where('id', $params['bankAccount']['id'])->update([
                'audit_state' => $params['bankAccount']['audit_state'],
            ]);

            if(empty($params['workerInfo']['id']) || empty($params['workerAgree']['id']) || empty($params['bankAccount']['id'])) {
                $audit_state = 3;
            }elseif ((int)$params['workerInfo']['audit_state'] === 0 || (int)$params['workerAgree']['audit_state'] === 0 || (int)$params['bankAccount']['audit_state'] === 0){
                $audit_state = 0;
            }elseif ((int)$params['workerInfo']['audit_state'] === 2 || (int)$params['workerAgree']['audit_state'] === 2 || (int)$params['bankAccount']['audit_state'] === 2){
                $audit_state = 2;
            }else{
                $audit_state = 1;
            }
            MasterWorker::where('id', $params['id'])->update([
                'audit_state' => $audit_state,
            ]);

            Db::commit();

            if($audit_state == 1){
                // 工程师基本信息审核通知【给工程师的通知】
                event('Notice',  [
                    'scene_id' => 123,
                    'params' => [
                        'user_id' => 0,
                        'mobile' => $params['mobile'],
                    ]
                ]);
            }

            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function delete(array $params): bool
    {
        return MasterWorkerAgree::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public static function detail($params): array
    {
        return MasterWorkerAgree::findOrEmpty($params['id'])->toArray();
    }
}